﻿using FlyNetwork.Sockets.Http;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TestServer
{

    public class TestHttp
    {
        THttpListener _HttpListener;
        public TestHttp()
        {
            string[] strUrl = new string[] { "http://*/Test/" };
            _HttpListener = new THttpListener(strUrl);
            _HttpListener.ResponseEvent += _HttpListener_ResponseEvent;
            _HttpListener.Start();
        }

        void _HttpListener_ResponseEvent(System.Net.HttpListenerContext ctx)
        {
            //直接获取数据
            Dictionary<string, string> rets = _HttpListener.getData(ctx);
            //获取get数据
            Dictionary<string, string> retGets = _HttpListener.getData(ctx, THttpListener.DataType.Get);
            //获取post数据
            Dictionary<string, string> retPosts = _HttpListener.getData(ctx, THttpListener.DataType.Post);
            ResponseWrite(ctx.Request.AcceptTypes[0], "Ret", ctx.Response);
        }

        static void ResponseWrite(string type, string msg, System.Net.HttpListenerResponse response)
        {
            //使用Writer输出http响应代码
            using (System.IO.StreamWriter writer = new System.IO.StreamWriter(response.OutputStream, new UTF8Encoding()))
            {
                response.ContentType = type + ";charset=utf-8";
                writer.WriteLine(msg);
                writer.Close();
                response.Close();
            }
        }
    }
}
